Attribute VB_Name = "basDeklare"
Option Explicit
'Objekte
Public objDrive    As cDrive
Public objReg      As cRegistry
Public objTray     As cTray

Public Const REG_AutoStart As String = "SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
'Public Const GB As Long = 1024 ^ 3
'Public Const MB As Long = 1024 ^ 2

'Programmversion
Public Const VERSION As String = "2.1"

'TrayIcon
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Const ICON_USB_STICK_FOUND As Integer = 102
Public Const ICON_NO_USB_STICK As Integer = 101
'###

'Folderbrowse Dialog
'Browse Dialog
Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias _
  "SHBrowseForFolderA" (lpbi As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias _
  "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)

Private Declare Function DestroyWindow Lib "user32" ( _
     ByVal hwnd As Long) As Long

Private Type BROWSEINFO
  hwndOwner As Long
  pidlRoot As Long
  pszDisplayName As String
  lpszTitle As String
  ulFlags As Long
  lpfn As Long
  lParam As Long
  iImage As Long
End Type

Private Type SHITEMID
  cbSize As Integer
  abID As String * 256
End Type

Private Type ITEMIDLIST
  mkid As SHITEMID
End Type

' Nur Computer als Auswahl erlaubt. Wenn der Anwender andere
' Ordner markiert, kann der OK-Schalter nicht ausgewhlt
' werden.
Private Const BIF_BROWSEFORCOMPUTER = &H1000

' Nur Drucker als Auswahl erlaubt. Wenn der Anwender andere
' Ordner markiert, kann der OK-Schalter nicht ausgewhlt
' werden.
Private Const BIF_BROWSEFORPRINTER = &H2000

' Der Dialog zeigt neben den Ordnern auch Dateien.
Private Const BIF_BROWSEINCLUDEFILES = &H4000

' Der Dialog zeigt keine Netzwerkordner unterhalb der
' aktuellen Domain.
Private Const BIF_DONTGOBELOWDOMAIN = &H2

' Nur Dateisystemobjekte als Auswahl erlaubt. Wenn der
' Anwender andere Ordner markiert, kann der OK-Schalter
' nicht ausgewhlt werden.
Private Const BIF_RETURNFSANCESTORS = &H8

' Nur Dateisystemordner als Auswahl erlaubt. Wenn der
' Anwender andere Ordner markiert, kann der OK-Schalter
' nicht ausgewhlt werden.
Private Const BIF_RETURNONLYFSDIRS = &H1

' Der Dialog enthlt eine Statuszeile. Die Rckruffunktion
' kann die Statuszeile ausfllen
Private Const BIF_STATUSTEXT = &H4

' (Win 2000) Zeigt ein neuen Dialog an mit mehr
' benutzerfreundlichen nderungen
Private Const BIF_USENEWUI = &H40

' (ab IE 4.0) Sendet an die Callback Funktion eine
' BFFM_VALIDATEFAILED Message, wenn in der Textbox eine falsche
' Eingabe gemacht wurde
Private Const BIF_VALIDATE = &H20

' Enabled den OK-Button, wenn lParam ungleich 0 ist,
' andernfalls wird der Button Disabled
Private Const BFFM_ENABLEOK = &H465

' Setzt die Selektierung auf einen Verzeichnisbaumeintrag
' lParam gibt hierbei den Pfad an und wParam muss ungleich 0 sein
Private Const BFFM_SETSELECTION = &H466

' Setzt den Staustext des Dialogs.
' lParam gibt den auszugebenden Text an
Private Const BFFM_SETSTATUSTEXT = &H464

' Callback Ereignis-Messages
' --------------------------

' Dialog wurde initialisiert, lParam ist 0
Private Const BFFM_INITIALIZED = 1

' Benutzer hat ein anderen Verzeichnisbaumeintrag gewhlt
Private Const BFFM_SELCHANGED = 2

' (ab IE 4.0) Benutzer hat eine falsche Angabe
' in der Textbox des Dialogs gemacht
Private Const BFFM_VALIDATEFAILED = 3

Private Const BIF_EDITBOX = &H10

'Pfad automatisch ffnen
Public bOpenAutomatic As Boolean

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
    (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, _
    lParam As Any) As Long

Public Const WM_RBUTTONUP       As Long = &H205
Public Const WM_LBUTTONDBLCLK   As Long = &H203
Private Const WM_LBUTTONDOWN    As Long = &H201


Private Const H_MAX             As Long = &HFFFF + 1
Private Const HDN_LAST          As Long = H_MAX - 399&
Private Const HDN_FIRST         As Long = -300&


Private Const HHT_ONHEADER          As Long = &H2
Private Const HHT_ONDIVIDER         As Long = &H4
Private Const LVM_FIRST             As Long = &H1000
Private Const LVM_SETCOLUMNWIDTH    As Long = (LVM_FIRST + 30)
Private Const HDN_ITEMCHANGEDW      As Long = (HDN_FIRST - 21)
Private Const HDN_DIVIDERDBLCLICKA  As Long = (HDN_FIRST - 5)
Private Const HDN_DIVIDERDBLCLICKW  As Long = (HDN_FIRST - 25)
Private Const HDN_ITEMCHANGEDA      As Long = (HDN_FIRST - 1)
Private Const HDN_ITEMCHANGINGA     As Long = (HDN_FIRST - 0)
Private Const HDN_ITEMCHANGINGW     As Long = (HDN_FIRST - 20)
Private Const HDN_ENDDRAG           As Long = (HDN_FIRST - 11)
Private Const HDN_BEGINTRACKA       As Long = (HDN_FIRST - 6)

Public Const LVM_GETHEADER          As Long = (LVM_FIRST + 31) 'gibt Handle des

'Memory kopieren
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'Subclassing
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Const GWL_WNDPROC = (-4&)

'Nachricht wenn Gert hinzugefgt wird
Private Type Guid
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Const WM_DEVICECHANGE   As Long = &H219
Private Const WM_DESTROY        As Long = &H2
Private Const WM_NOTIFY         As Long = &H4E&

'header class id's
Public Const HEADER32_CLASS   As String = "SysHeader32"
Public Const HEADER_CLASS     As String = "SysHeader"

'header info
Public Const HDI_WIDTH        As Long = &H1
Public Const HDI_HEIGHT       As Long = HDI_WIDTH
Public Const HDI_TEXT         As Long = &H2
Public Const HDI_FORMAT       As Long = &H4
Public Const HDI_LPARAM       As Long = &H8
Public Const HDI_BITMAP       As Long = &H10
Public Const HDI_IMAGE        As Long = &H20
Public Const HDI_DI_SETITEM   As Long = &H40
Public Const HDI_ORDER        As Long = &H80

'header formats
Public Const HDF_LEFT         As Long = 0
Public Const HDF_RIGHT        As Long = 1
Public Const HDF_CENTER       As Long = 2
Public Const HDF_JUSTIFYMASK  As Long = &H3
Public Const HDF_RTLREADING   As Long = 4
Public Const HDF_IMAGE        As Long = &H800
Public Const HDF_OWNERDRAW    As Long = &H8000&
Public Const HDF_STRING       As Long = &H4000
Public Const HDF_BITMAP       As Long = &H2000
Public Const HDF_BITMAP_ON_RIGHT  As Long = &H1000

'header styles
Public Const HDS_HORZ         As Long = &H0
Public Const HDS_BUTTONS      As Long = &H2
Public Const HDS_HOTTRACK     As Long = &H4
Public Const HDS_HIDDEN       As Long = &H8
Public Const HDS_DRAGDROP     As Long = &H40
Public Const HDS_FULLDRAG     As Long = &H80

'header messages
Public Const HDM_FIRST           As Long = &H1200
Public Const HDM_GETITEMCOUNT    As Long = (HDM_FIRST + 0)
Public Const HDM_INSERTITEM      As Long = (HDM_FIRST + 1)
Public Const HDM_DELETEITEM      As Long = (HDM_FIRST + 2)
Public Const HDM_GETITEM         As Long = (HDM_FIRST + 3)
Public Const HDM_SETITEM         As Long = (HDM_FIRST + 4)
Public Const HDM_LAYOUT          As Long = (HDM_FIRST + 5)
Public Const HDM_HITTEST         As Long = (HDM_FIRST + 6)
Public Const HDM_GETITEMRECT     As Long = (HDM_FIRST + 7)
Public Const HDM_SETIMAGELIST    As Long = (HDM_FIRST + 8)
Public Const HDM_GETIMAGELIST    As Long = (HDM_FIRST + 9)
Public Const HDM_ORDERTOINDEX    As Long = (HDM_FIRST + 15)

'notify messages
Public Const HDN_ITEMCLICK = (HDN_FIRST - 2)
Public Const HDN_DIVIDERDBLCLICK = (HDN_FIRST - 5)
Public Const HDN_BEGINTRACK = (HDN_FIRST - 6)
Public Const HDN_ENDTRACK = (HDN_FIRST - 7)
Public Const HDN_TRACK = (HDN_FIRST - 8)
Public Const HDN_GETDISPINFO = (HDN_FIRST - 9)
Public Const HDN_BEGINDRAG = (HDN_FIRST - 10)
Public Const HDN_ITEMCHANGING As Long = (HDN_FIRST - 0)
Public Const HDN_ITEMDBLCLICK As Long = (HDN_FIRST - 3)

Public Const NM_FIRST As Long = &H0
Public Const NM_RCLICK As Long = (NM_FIRST - 5)

'gerte nachrichten
Private Const DBT_DEVICEARRIVAL             As Long = 32768
Private Const DBT_DEVICEQUERYREMOVE         As Long = 32772
'Private Const DBT_DEVICEQUERYREMOVEFAILED   As Long = &H8002
'Private Const DBT_DEVICEREMOVECOMPLETE      As Long = &H8004
'Private Const DBT_DEVICEREMOVEPENDING       As Long = &H8003
'Private Const DBT_DEVICETYPESPECIFIC        As Long = &H8005

'Private Const DBT_DEVTYP_DEVICEINTERFACE As Long = &H5
'Private Const DBT_DEVTYP_DEVNODE As Long = &H1
'Private Const DBT_DEVTYP_NET As Long = &H4
'Private Const DBT_DEVTYP_HANDLE As Long = &H6
'Private Const DBT_DEVTYP_OEM As Long = &H0
'Private Const DBT_DEVTYP_PORT As Long = &H3
'Private Const DBT_DEVTYP_VOLUME As Long = &H2

Private Declare Function GetCursorPos Lib "user32" _
   (lpPoint As POINTAPI) As Long
   
Private Declare Function ScreenToClient Lib "user32" _
   (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
   
Private Type NMHDR
   hWndFrom As Long
   idfrom   As Long
   code     As Long
End Type

Private Type HD_ITEM
   mask        As Long
   cxy         As Long
   pszText     As String
   hbm         As Long
   cchTextMax  As Long
   fmt         As Long
   lParam      As Long
   iImage      As Long
   iOrder      As Long
End Type

Private Type NMHEADER
   hdr         As NMHDR
   iItem       As Long
   iButton     As Long
   hbm         As Long
   HDI         As HD_ITEM
End Type

Private Type POINTAPI
   X As Long
   Y As Long
End Type

Private Type HD_HITTESTINFO
   pt  As POINTAPI
   flags  As Long
   iItem As Long
End Type

Private PrevWndProc                     As Long
Private PrevWndProc_ListView            As Long

Public mb_AutoCheck                     As Boolean

Private Function HiWord(lDWord As Long) As Integer
  HiWord = (lDWord And &HFFFF0000) \ &H10000
End Function

Private Function LOWORD(lDWord As Long) As Integer
  If lDWord And &H8000& Then
    LOWORD = lDWord Or &HFFFF0000
  Else
    LOWORD = lDWord And &HFFFF&
  End If
End Function

Private Function SubWndProc(ByVal hwnd As Long, ByVal Msg As Long, _
                            ByVal wParam As Long, ByVal lParam As Long) _
                            As Long
                            


Select Case Msg

'Fehler wg. Schutzverletzung verhindern
Case WM_DESTROY:
                        Call Terminate(hwnd)

  
Case WM_DEVICECHANGE:
                        If mb_AutoCheck Then
                            If wParam = DBT_DEVICEARRIVAL Then
                                objTray.TrayIcon_Icon = LoadResPicture(ICON_USB_STICK_FOUND, vbResIcon)
                                objTray.TrayIcon_Modify frmMain.Caption, objTray.TrayIcon_Icon
                                objDrive.mp_GetDriveTyps
                                objDrive.ChooseUSB_Info objDrive.p_GetDriveLetters("0")
                                If bOpenAutomatic Then objDrive.OpenDir objDrive.p_GetDriveLetters("0") & objDrive.mp_StandardPfad
                                
                            ElseIf wParam = DBT_DEVICEQUERYREMOVE Then
                                objDrive.RemoveUSB_Info
                                objTray.TrayIcon_Icon = LoadResPicture(ICON_NO_USB_STICK, vbResIcon)
                                objTray.TrayIcon_Modify frmMain.Caption, objTray.TrayIcon_Icon
          
                            End If
                        End If
End Select
  
    'Ursprngliche Fensterprozedur wieder aufrufen, die eingelaufenen
    'Nachrichten werden durchgereicht,
    SubWndProc = CallWindowProc(PrevWndProc, hwnd, Msg, wParam, lParam)
End Function

'Starten des Subclassings und speichern der alten
'Einsprungsadresse
Public Sub Init(hwnd As Long)
    PrevWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf SubWndProc)
End Sub

'Auflsen des Subclassings und wiederherstellen der
'Einsprungsadresse der ursprnglichen Fensterprozedur
Public Sub Terminate(hwnd As Long)
    'objTray.TrayIcon_Delete
    Call SetWindowLong(hwnd, GWL_WNDPROC, PrevWndProc)
End Sub

'Starten des Subclassings und speichern der alten
'Einsprungsadresse (frmAuswahl)
Public Sub Init_lstV(hwnd As Long)
    PrevWndProc_ListView = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf SubWndProc_LstV)
End Sub

'Auflsen des Subclassings und wiederherstellen der
'Einsprungsadresse der ursprnglichen Fensterprozedur
Public Sub Terminate_lstV(hwnd As Long)
    Call SetWindowLong(hwnd, GWL_WNDPROC, PrevWndProc_ListView)
End Sub


Private Function SubWndProc_LstV(ByVal hwnd As Long, ByVal Msg As Long, _
                                 ByVal wParam As Long, ByVal lParam As Long) _
                                 As Long
Static nm           As NMHDR
Static pt           As POINTAPI
Static HTI          As HD_HITTESTINFO
Static bReturn      As Boolean

Dim hHeader         As Long
Dim thisIndex       As Long

bReturn = True
Select Case Msg

    'auf NOTIFY Message des ListViews abprfen
    'lParam beinhaltet Zeiger auf HTI struct
    
    Case WM_NOTIFY:
                            
                        'Get the notification message
                        'nm ist vom Typ HTI
                        'nm.code enthlt Identifikation der Aktion
                        'die im Header durchgefhrt wurde
                         Call CopyMemory(nm, ByVal lParam, Len(nm))
                         
                        'get the hwnd of the header
                         hHeader = SendMessage(hwnd, _
                                               LVM_GETHEADER, _
                                               0&, _
                                               ByVal 0&)
                        
                        If hHeader Then
                        'get the current cursor position in the header
                            Call GetCursorPos(pt)
                            Call ScreenToClient(hHeader, pt)
                            
                           'get the header's hit-test info
                            With HTI
                               .flags = HHT_ONHEADER Or HHT_ONDIVIDER
                               .pt = pt
                            End With
                
                            Call SendMessage(hHeader, HDM_HITTEST, 0&, HTI)
                                  
                           'react to the HDN_* code
                            Select Case nm.code
                                Case HDN_ENDTRACK:          'Msg = -1 'Debug.Print "HDN_ENDTRACK"
                                Case HDN_BEGINTRACK:        'Msg = -1 'Debug.Print "HDN_BEGINTRACK"
                                
                                'resize abfangen und nicht zulassen
                                'Doppelklick verursacht auch ein Resize, deshalb
                                'muss HDN_DIVIDERDBLCLICK nicht exlizit
                                'abgefangen werden.
                                Case HDN_ITEMCHANGING:      SubWndProc_LstV = 1
                                                            Exit Function
                                                            
                                                           
                                Case HDN_BEGINDRAG:         'Msg = -1 'Debug.Print "HDN_BEGINDRAG"
                                Case HDN_ENDDRAG:           'Msg = -1 'Debug.Print "HDN_ENDDRAG"
                                
                                'Doppelklick abfangen
                                'Case HDN_DIVIDERDBLCLICK:   Msg = -1 'Debug.Print "HDN_DIVIDERDBLCLICK"
                            End Select
                        End If
    Case WM_DESTROY:          Call Terminate(hwnd)
  
End Select
  
    SubWndProc_LstV = CallWindowProc(PrevWndProc_ListView, hwnd, Msg, wParam, lParam)
 
End Function

' Hier treffen die Ereignisse des Dialogs ein
Private Function BCallbackProc(ByVal hwnd As Long, ByVal uMsg As Long, _
  ByVal lParam As Long, ByVal lpData As Long) As Long

Dim retval As Long
Dim TmpSelected As String * 2048
Static LastPath As String
Dim spPath() As String
  
  ' Ereignisse des Dialoges
Select Case uMsg
    ' Dialog wird angezeigt
    Case BFFM_INITIALIZED
      ' Startordner festlegen
                SendMessage hwnd, BFFM_SETSELECTION, ByVal 1&, ByVal objDrive.p_GetDriveLetters(0) & objDrive.mp_StandardPfad
    
    ' Benutzer whlt einen andern Ordner
    Case BFFM_SELCHANGED
      ' Ausgewhlten Eintrag ermitteln
        SHGetPathFromIDList lParam, TmpSelected
        'NullChars entfernen
        
        LastPath = Left$(TmpSelected, InStr(1, TmpSelected, vbNullChar) - 1)
            If Len(LastPath) >= 60 Then
                spPath = Split(LastPath, "\")
                ReDim Preserve spPath(UBound(spPath))
                'Pfad gekrzt wieder zusammensetzen
                LastPath = spPath(0) & "\...\" & spPath(UBound(spPath) - 1) & "\" & _
                          spPath(UBound(spPath))
            Else
                LastPath = Left$(TmpSelected, InStr(1, TmpSelected, vbNullChar) - 1)
            End If
            
          ' Ausgewhlten Ordner in der Statuszeile anzeigen
        SendMessage hwnd, BFFM_SETSTATUSTEXT, ByVal 1&, ByVal _
        "Sie haben " & LastPath & " gewhlt."
    
        ' ungltige Eingabe in der Textbox des Dialogs
    Case BFFM_VALIDATEFAILED
          ' Letzten ausgewhlten Ordner selektieren
          SendMessage hwnd, BFFM_SETSELECTION, ByVal 1&, ByVal LastPath
          
    Case Else
        Debug.Print uMsg
End Select
End Function

' Dient der Ermittlung der AddressOf-Funktionsadresse
' von BrowsCallBack
Private Function GetAddress(ByVal FuncAddress As Long) As Long
  GetAddress = FuncAddress
End Function

'Folderbrowse Dialog
Public Function GetFolder(ByVal sTitel As String, lhWnd As Long) As String
Dim bI As BROWSEINFO
Dim Item As ITEMIDLIST
Dim retval As Long
Dim RetStr As String * 256

' Dialog-Eigenschaften und Vorgabewerte setzen
With bI
    .ulFlags = BIF_RETURNONLYFSDIRS Or BIF_VALIDATE Or _
    BIF_STATUSTEXT Or BIF_EDITBOX
    .hwndOwner = lhWnd
    .pszDisplayName = Space$(512)
    .lpszTitle = sTitel & vbNullChar
    
    .lpfn = GetAddress(AddressOf BCallbackProc)
End With

' Dialog aufrufen
retval = SHBrowseForFolder(bI)
    If retval = 0 Then
        GetFolder = ""
        Exit Function
    End If

  ' Ausgewhlten Pfad ermitteln
retval = SHGetPathFromIDList(retval, RetStr)
    If retval = 0 Then
        MsgBox "Fehler beim Extrahieren des ausgewhlten Pfades", vbCritical, frmMain.Caption
        Exit Function
    Else
        GetFolder = Left$(RetStr, InStr(1, RetStr, vbNullChar) - 1)
    End If
  ' Ressourcen wieder freigeben
CoTaskMemFree retval
End Function

