VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cLV"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetWindowLong Lib "user32" Alias _
"GetWindowLongA" _
    (ByVal hwnd As Long, ByVal nIndex As Long) As Long

Private Declare Function SetWindowLong Lib "user32" Alias _
"SetWindowLongA" _
    (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As _
    Long) As Long

Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, _
    ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, _
    ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" ( _
     ByVal lpClassName As String, _
     ByVal lpWindowName As String) As Long

Private Const GWL_STYLE = (-16) 'Fensterstil

Private Const LVM_SETCOLUMNWIDTH = &H101E 'gibt an, dass
' Spaltenbreite gesetzt werden soll
Private Const LVSCW_AUTOSIZE = (-1) 'automatisch optimale Spaltenbreite
Private Const LVSCW_AUTOSIZE_USEHEADER = (-2) 'sorgt dafr, dass alle
' Spaltenberschriften lesbar sind

Private Const LVM_FIRST = &H1000
' ListViewHeaders zurck

Private Const HDS_BUTTONS As Long = &H2 'Headerstil "Buttons"

Private Const SWP_NOMOVE As Long = &H2 'Fenster nicht verschieben
Private Const SWP_NOSIZE As Long = &H1 'Fenstergre nicht ndern
Private Const SWP_NOZORDER As Long = &H4 'Fensteranordnung (vorne,

' hinten) nicht ndern
Public Function GetHeaderHandle(ByRef CListView As ListView)
GetHeaderHandle = SendMessage(CListView.hwnd, LVM_GETHEADER, 0, 0)
End Function

Public Function FlatListView(ByRef CListView As ListView, COwner As Form) As Long
    
    Dim hHeader As Long, lStyle As Long
    
    hHeader = SendMessage(CListView.hwnd, LVM_GETHEADER, 0, 0)
    lStyle = GetWindowLong(hHeader, GWL_STYLE)
    'Debug.Print lStyle
    lStyle = lStyle Xor HDS_BUTTONS
    
    If lStyle Then
        SetWindowLong hHeader, GWL_STYLE, lStyle
        SetWindowPos CListView.hwnd, COwner.hwnd, 0, 0, 0, 0, _
        SWP_NOMOVE Or SWP_NOZORDER Or SWP_NOSIZE
    End If
    
End Function

Public Sub OptimalHeaderWidth(ByRef CListView As ListView)
    
    Dim i As Integer
    
    
    '//Alle Spaltenkpfe durchgehen
    For i = 1 To CListView.ColumnHeaders.Count - 1
        
        
        SendMessage CListView.hwnd, LVM_SETCOLUMNWIDTH, i, -3
        
    Next i
    
End Sub

