VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" Alias _
        "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal _
        ByteLen As Long)
        
Private Rot(1) As Long, Gruen(1) As Long, Blau(1) As Long

Public Sub EndFarbe(R0 As Integer, G0 As Integer, B0 As Integer)
  Rot(0) = R0
  Gruen(0) = G0
  Blau(0) = B0
End Sub
  
Public Sub StartFarbe(R1 As Integer, G1 As Integer, B1 As Integer)
  Rot(1) = R1
  Gruen(1) = G1
  Blau(1) = B1
End Sub

Public Function ShowProgress(PicProgress As PictureBox, _
  ByVal Value As Long, ByVal Min As Long, ByVal Max As Long, _
  Optional ByVal bShowProzent As Boolean = False)
    
    Dim B               As Long
    Dim H               As Long
    Dim intProz         As Integer
    Dim strProz         As String
    Dim Farblong        As Long
    Dim cRGB(0 To 3)    As Byte
    Dim Grauwert        As Long
    Dim Beginn          As Integer
    Dim X               As Double
    Dim XX              As Double
    Dim AktuelleFarbe   As Long
    Dim lM              As Long
  
    ' Plausibilittsprfungen
    If Value < Min Then Value = Min
    If Value > Max Then Value = Max
    
    ' Prozentwert ausrechnen
    If Max > 0 Then
        intProz = Int(Value / Max * 100 + 0.5)
    Else
        intProz = 100
    End If
    
    With PicProgress
        ' Prfen, ob AutoReadraw=True
        If .AutoRedraw = False Then .AutoRedraw = True
        
        ' Inhalt lschen
        PicProgress.Cls
        
        'B = .ScaleWidth
        B = ((.ScaleWidth - 2) / 100) * Value
        H = .ScaleHeight
        If Value > 0 Then
            Dim lR As Long
            Dim lG As Long
            Dim lB As Long
            
            Beginn = 0
            
            ' Balken anzeigen
            For X = Beginn To Value / 100 Step 0.01
                XX = X
                
                lR = Rot(0) - (Rot(0) - Rot(1)) * XX
                lG = Gruen(0) - (Gruen(0) - Gruen(1)) * XX
                lB = Blau(0) - (Blau(0) - Blau(1)) * XX
                
                AktuelleFarbe& = RGB(lR, lG, lB)
                                 
                PicProgress.Line (X * B, 0)-((X + 0.01) * B, H), _
                                 AktuelleFarbe&, BF
                'PicProgress.Line (x * B, H - 5)-((x + 0.01) * B, (H + 50) / 2), _
                                 RGB(0, 0, 255), BF
            Next
            'lM = Value / 100
            
            'Farbe fr 2. Farbverlauf setzen
            StartFarbe 0, 200, 0
            EndFarbe 200, 0, 0
            
            'Anfang an das Ende des ersten Farbverlaufs setzen und bis Ende schleifen
            For X = Value / 100 To 1 Step 0.01
                XX = X

                lR = Rot(0) - (Rot(0) - Rot(1)) * XX
                lG = Gruen(0) - (Gruen(0) - Gruen(1)) * XX
                lB = Blau(0) - (Blau(0) - Blau(1)) * XX

                AktuelleFarbe& = RGB(lR, lG, lB)

                PicProgress.Line (X * B, 0)-((X + 0.01) * .ScaleWidth, H), _
                                 AktuelleFarbe&, BF
            Next
            If bShowProzent Then
                strProz = CStr(intProz) & " %"
                .CurrentX = (.ScaleWidth - .TextWidth(strProz)) / 2
                .CurrentY = (.ScaleHeight - .TextHeight(strProz)) / 2
                
                ' Vordergrundfarbe
                Farblong = PicProgress.Point(.CurrentX, .CurrentY)
                
                ' in RGB Werte splitten
                Call CopyMemory(cRGB(0), Farblong, 4)
                
                ' den Graustufenwert nach Gewichtung fr Monitore berechnen
                Grauwert = (0.3 * cRGB(0)) + (0.59 * cRGB(1)) + (0.11 _
                * cRGB(2))
                .ForeColor = IIf(Grauwert > 127, vbBlack, vbWhite)
                
                PicProgress.Print strProz
            End If
        End If
    End With
End Function

