VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uID As Long
    UFlags As Long
    uCallbackmessage As Long
    hIcon As Long
    szTip As String * 64
End Type


Private t As NOTIFYICONDATA

Private Const NIM_ADD       As Long = &H0
Private Const NIM_MODIFY    As Long = &H1
Private Const NIM_DELETE    As Long = &H2
Private Const NIF_MESSAGE   As Long = &H1
Private Const NIF_ICON      As Long = &H2
Private Const NIF_TIP       As Long = &H4
Private Const WM_MOUSEMOVE  As Long = &H200

Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" _
                 (ByVal dwMessage As Long, IpData As NOTIFYICONDATA) As Long

Private hwnd        As Long
Private m_TrayIcon  As IPictureDisp

Public Property Get TrayIcon_Icon() As StdPicture
Set TrayIcon_Icon = m_TrayIcon
End Property

Public Property Let TrayIcon_Icon(ByVal lNew As StdPicture)
Set m_TrayIcon = lNew
End Property

'Public Property Set TrayIcon_Icon(ByVal lNew As IPictureDisp)
'm_TrayIcon = lNew
'End Property

Public Sub TrayIcon_Set(ByVal lhWnd As Long, _
                        ByVal sCaption As String)

    t.cbSize = Len(t)
    t.hwnd = lhWnd
    hwnd = lhWnd
    t.uID = 1&
    t.UFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
    t.uCallbackmessage = WM_MOUSEMOVE
    t.hIcon = m_TrayIcon
    t.szTip = sCaption & Chr$(0)
    Shell_NotifyIcon NIM_ADD, t
    
End Sub

Public Sub TrayIcon_Delete()
    't.hWnd = hWnd
    Shell_NotifyIcon NIM_DELETE, t
End Sub

Public Sub TrayIcon_Modify(ByVal sCaption As String, _
                           Optional lIcon As Long = -1)
    t.cbSize = Len(t)
    t.hwnd = hwnd
    If IsMissing(lIcon) Then lIcon = t.hIcon
    t.hIcon = lIcon
    t.szTip = sCaption & Chr$(0)
    Shell_NotifyIcon NIM_MODIFY, t
    
End Sub

Private Sub Class_Terminate()
TrayIcon_Delete
End Sub
